ALTER TABLE `UserGameIdents`
    CHANGE `CreatedAt` `CreatedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6);

ALTER TABLE `UserGameIdents`
    CHANGE `LastModifiedAt` `LastModifiedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6) ON UPDATE CURRENT_TIMESTAMP(6);

CREATE TABLE IF NOT EXISTS `UserGameIdentsHistory`
(
    `Id`           BIGINT(20)   NOT NULL,
    `UserId`       BIGINT(20)   NOT NULL,
    `GameServerId` BIGINT(20)   NOT NULL,
    `Ident`        VARCHAR(255) NOT NULL,
    `Deleted`      BOOL DEFAULT FALSE,
    `DateFrom`     DATETIME(6)  NOT NULL,
    `DateTo`       DATETIME(6)  NOT NULL
);

DROP TRIGGER IF EXISTS `TR_UserGameIdentsUpdate`;

CREATE TRIGGER `TR_UserGameIdentsUpdate`
    AFTER UPDATE
    ON `UserGameIdents`
    FOR EACH ROW
BEGIN
    INSERT INTO `UserGameIdentsHistory` (
        `Id`, `UserId`, `GameServerId`, `Ident`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.Id, OLD.UserId, OLD.GameServerId, OLD.Ident, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;

DROP TRIGGER IF EXISTS `TR_UserGameIdentsDelete`;

CREATE TRIGGER `TR_UserGameIdentsDelete`
    AFTER DELETE
    ON `UserGameIdents`
    FOR EACH ROW
BEGIN
    INSERT INTO `UserGameIdentsHistory` (
        `Id`, `UserId`, `GameServerId`, `Ident`, `Deleted`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.Id, OLD.UserId, OLD.GameServerId, OLD.Ident, TRUE, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;