from cpl_core.configuration.configuration_model_abc import ConfigurationModelABC
from cpl_query.extension import List

from bot_data.model.level import Level


class DefaultLevelSettings(ConfigurationModelABC):
    def __init__(self, level_header: str = None, levels: list = None):
        ConfigurationModelABC.__init__(self)

        self._levels = List(Level)
        self._level_header = level_header

        if levels is None:
            return
        for level in levels:
            self._levels.append(
                Level(
                    level["Name"],
                    level["Color"],
                    int(level["MinXp"]),
                    int(level["Permissions"]),
                    None,
                )
            )

    @property
    def levels(self) -> List[Level]:
        return self._levels

    @property
    def level_header(self) -> str:
        return self._level_header
